# History

## 4.12.6

- [wls_install_domain] Fix reading of xml files for resources

## 4.12.5

- [wls_install_domain] Fix reading of plan deployment file

## 4.12.4

- [wls_install_domains] Guard agains empty name in config.xml

## 4.12.3

- [rcu] use specified sysdba on check

## 4.12.2

- [rcu] use specified sysdba on check

## 4.12.1

- [domain] Fix typo

## 4.12.0

- [rcu,domain] Make connecting as sysdba configurable

## 4.11.2

- [rcu] Fix missing space between command parts

## 4.11.1

- [rcu] Fix extra space between password and sysdba

## 4.11.0

- [rcu] Infer non-sysdba account when specified account is not sys

## 4.10.4

- [ora_install_homes] Use default location if oraInst.loc does not exists
- [domain] Fix missing space in server arguments


## 4.10.3

- [copydomain] Fix Using custom trust for enrolling domain

## 4.10.2

- [nodemanagerautostart] Add bash to ExecStart & ExecStop in unit file

## 4.10.1

- [fmw] Fix detection of installed FMW product

## 4.10.0

- [docs] Regenerated docs
- [nodemanagerautostart] Add support for environment file for system unit

## 4.9.1

- [fmw] Typo; changed 12219 to 122119

## 4.9.0

- [fmw] Add support for forms and reports 12.2.1.19

## 4.8.3

- [wls_physical_patches] Fix filter_map issue on jruby

## 4.8.2

- [nodemanager] Removed stdlib::merge dependency

## 4.8.1

- [nodemanager] Fix deprecated merge call

## 4.8.0

- [core] Add support for Puppet 8

## 4.7.3

- [nodemanagerautostart] Fix systemd autostart

## 4.7.2

- [software_version] Fix undefined reference.

## 4.7.1

- [software_vesrion] Remove unzip package


## 4.7.0

- [core] Add support for EL9
- [software_version] Ensure unzip is installed in time

## 4.6.1

- [nodemanager] Fix on initial run with java_update_window set

## 4.6.0

- [wls_java_home] Add support to manage java home in extra files

## 4.5.1

- [nodemanagerautostart] Fix typo

## 4.5.0

- [quality] Use strict linting
- [docs]Update format of documentation
- [nodemanager,domain,copydomain] Add support for scheduled java update

## 4.4.1

- [wls_java_home] Added config_bootstrap.xml to list of files

## 4.4.0

- [copydomain] Add support for switching java_home

## 4.3.1

- [release] Fix content of package
- [wls_java_home] Add short description of the type

## 4.3.0

- [nodemanager] Restart nodemanager after java_home change
- [domain] Add support for switching java_home
- [wls_java_home] Initial implementation

## 4.2.4

- [copydomain] create intermediate log dirs with correct mode

## 4.2.3

- [nodemanager] create intermediate log dirs with correct mode
- [domain] Create intermediate log dirs with correct mode

## 4.2.2

- [domain] Create log directories with correct owner and mode

## 4.2.1

- [software_version] Fix when umask is set to 077

## 4.2.0

- [release] Add support for AlmaLinux and Rocky

## 4.1.1

- [wls_install_homes] Fix load error

## 4.1.0

- [core] Use cleanup type instead of exec for cleaning up
- [functions/wls_patches_missing] Add support for sub_patches
- [functions/wls_physical_patches] Add support for sub_patches

## 4.0.2

- [fact_caching] Handle puppet versions older than V5

## 4.0.1

- [clear_caches] Remove bsu type from caching logic
- [docs] Update software versions

## 4.0.0

- [function/running_domains] Initial implementation
- [release] remove all deprecated functionality
- [core] Implement fact caching

## 3.11.5

- [copydomain] Remove standard created nodemanager.properties

## 3.11.4

-[copydomain] Add support for non-standard admin ports

## 3.11.3

- [nodemanager] Fix for using standard trust with custom identity
- [domain] Fix for using standard trust with custom identity

## 3.11.2

- [ords_homes] Fix detection of current homes

## 3.11.1

- [domain] Fix domain creation when administration_port_enabled false

## 3.11.0

- [domain] Add support for enabling administration port

## 3.10.1

[release] Change syntac of dependency fiddyspence-sleep
[docs] Fix description of the module
[doc] Updated docs and REFERENCE.md

## 3.10.0

- [wls_install_homes] Add running domains info to fact
- [functions/physical_patches] initial implementation
- [functions/patches_missing] initial implementation

## 3.9.0

- [release] Add puppet 7 support to the metadata
- [core] orawls_oracle_exists moved to the new namespace
- [ords_homes] Fix error when home does not exist

## 3.8.0

- [core] Add easy_type::debug_evaluation to all classes
- [software_version] Fix redeployment error
- [facts] Add support for removed homes in wls_install_homes fact

## 3.7.5

- [domain] Cleanup all files only needed during installation
- [software_version] Cleanup all files only needed during installation
- [rcu] Cleanup all files only needed during installation
- [fmw] Cleanup all files only needed during installation
- [software_version] cleanup fetched software and temporary created files

## 3.7.4

- [domain] Remove invalid nodemanager.properties after domain extensions are run (#38)

## 3.7.3

- [domain] Fix unrecognised variable $path error (#37)
- [core] Fix types in epp templates (#36)
- [core] Convert erb templates to epp

## 3.7.2

- [domain] Fix silent failure when somethin goes wrong with domain creation

## 3.7.1

- [domain] Make repository_password optional again

## 3.7.0

- [core] Add support for WebLogic 14

## 3.6.2

- [utils::webtier] Fix usage sensitive data type for passwords
- [utils::oimconfig] Fix usage sensitive data type for passwords
- [utils::fmw_clusterjrf] Fix usage sensitive data type for passwords
- [utils::fmw_cluster] Fix usage sensitive data type for passwords

## 3.6.1

- [domain] Fix sentive passwords for RCU

## 3.6.0

- [nodemanager] Fix idempotency on WebLogic 12.2.1.4
- [core] Add support for sensitive type for passwords
- [core] Make sure no usernames and passwords are echoed during a run

## 3.5.0

- [core] Add support for WebLogic 12.2.1.4
- [rcu] tabpespace and temp_tablespace options per component
- [rcu] Fix ordering of tablespace options
- [release] Add support for RHEL8 and remove support for RHEL5
- [domain] Add support for rcu_tablepspace and rcu_temp tablespace
- [fmw] Add missing BI silent template (#25)

## 3.4.2

- [core] Fix archive dependency

## 3.4.1

- [facts] Make facts resilient to empty domain.xml
- [release] Add trial license to README
- [core] Fix usage of root group on AIX
- [release] Cleanup some of the suported OS-es and version
- [docs] Update documentation
- [domain] add the ablity to create a BI publisher domain

## 3.4.0

- [core] Add AIX support
- [fmw] add bi_platform support for version 12213
- [functions] Change /web/ to /ohs/ after multiple tests
- [fmw] Update ora_inventory to auto add oraInventory
- [fmwjrf] Add middleware_home_dir + update logoutput not non 
- [domain] Add apps inside domain dir parameter

## 3.3.2

- [metadata] Allow Archive version 4
- [domain] Add support for app_dir inside domain_dir

## 3.3.1

- [ords] Fix fact no /etc/ords_homes file and older versions

## 3.3.0

- [opatchupgrade] Initial version

## 3.2.2

- [ords::software_version] Fix fetch from remote url
- [ords] Add source header

## 3.2.1

- [ords] Add function ords_installed

## 3.2.0

- [ords] Add initial support for installing ORDS

## 3.1.4

- [fmw] Fix FMW detection
- [fmw] Use extracted data type for fmq_product and function for making fmw idempotent
- [fmw_installed] Add function to verify specific if specific fusion product is installed
- [core] extraxt type Fmw_products
- [facts] Add installed features to oracle home fact

## 3.1.3

- [facts] Fix error when machine of server is undefined
- [docs] Fix documentation

## 3.1.2

- [domain] Fix syntax error

## 3.1.1

- [nodemanagerautostart] Fix support for multidomain in later WLS versions
- [core] Add ‘managed by puppet’ notices to templated files
- [copydomain] Add support for mutiple  domains
- [domain] Add support for mutiple  domains

## 3.1.0

- [core] Make sure no usernames and passwords are echoed during a run
- [domain] Add support for Forms domain and RCU
- [fmw] handle install type for  non soa and osb middleware types

## 3.0.6

-  facts] Fix error when deployment is not targetted
-  [core] Add puppet 6 unit tests
-  [docs] Added type information and defaul values to docs
-  [software_version] Add support for installing multiple homes with same version
-  [core] update archive module

## 3.0.5

- [facts] Remove an other debugger statement

## 3.0.4

- [facts] Remove debugger

## 3.0.3

- [facts] return empty hash when directory named in wls_domains.dat doesn’t exist
- [facts] Make sure rexml/document is available
- [test] Update tested Puppet versions
- [docs] First full doc setup

## 3.0.2

- [copydomain] Fix access to packed domain when using archive
- [quality] Add bundle check
- [development] Fix loading of wrong rspec-puppet gem.

## 3.0.1

- [nodemanager] Make implementation for 12.2.1.3. idempotent
- [fmw] Update the templates for 12.2.1.3
- [nodemanagerautostart] Add support for 12.2.1.3
- [nodemanager] Add support for 12.2.1.3
- [fmw] Add support for 12.2.1.3
- [domain] Add support for 12.2.1.3
- [release] Update metadata and README

## 3.0.0

- [facts] Fix FMW domain parsing
- [wls_adminserver] less output on regular run
- [domain] Don’t use deprecated property
- [core] Less standard output
- [fmw] Fix data form fmw class
- [functions] Fix when check returns a nil
- [packdomain] Add specs and make all variables camel case
- [managed_server] Fix default from wls_log_path
- [fmwlogdir] use camel case variables
- [domain] Use camel case variables
- [fmw] add correct prefix to module yaml data
- [functions] Move all functions to wls_install namespace
- [wls_adminserver] Only show wlst output when debugging
- [release] Clean old files
- [release] Add stdlib requirement

## 3.0.0-alpha.1

- [release] First Puppet 4 and 5 alpha release

## 2.1.12

- [release] prepare for publishing on forge

## 2.1.11

- [nodemanager] Idempotentie problem solved.
- [nodemanager] Fix lint errors
- [nodemanager] Fix for multiple nodemanagers on 1 system
- [nodemanager, nodemanagerautostart] Better systemd integration
- [copydomain] Use correct domains file
- [facts] Remove java_version & java_versions facts
- [copydomain] Fix require when using non standard copy
- [nodemanagerautostart] Fix execute bit on systemd service files
- [core] refactored to not use yaml_setting anymore.
- [domain] Filter out unsupported JVM options
- [facts] Add facts for java version numbers
- [nodemanagerautostart] Change unit from simple to notify when using RHEL 7 >
- [core] Use puppet 4 or higher on testing
- [functions] Fix lookup of variables on higher puppet versions
- [copydomain] Added basic support for own copyscript
- [core] Remove old non-used code

## 2.1.10

- [core] Make 'on_failure' for all log_output parameters
- [domain] Fix templating when non default machine name is used
- [domain] Make default log_output on_failure
- [packdomain] Fix issue with nodemaanager start on non admin-server node

## 2.1.9

- [nodemanagerautostart] Add parameter systemd_script_location
- [wls_adminserver] Fix reporting changes on refresh
- [wls_adminserver] Fix refreshonly behaviour

## 2.1.8

- [nodemanagerautostart] Add support for 12.2.1.2
- [domain] Fix creation of wrong nodemanager.properties
- [nodemanagerautostart] Remove keystore passphrase from start command
- [core] Updated to support WebLogic and Fusion 12.2.1.2

## 2.1.7

- [fmwcluster] Remove server foledrs of removed servers
- [rcu] Remove the pwd file after use. Closes #3
- [fmwcluster] Add missing SOA deployments. Closes #4
- [rcu] make default for rcu_soa_profile undef

## 2.1.6

- [domain, rcu] Add suppoort for rcu_honor_omf and rcu_soa_profile parameters

## 2.1.5

- [core] Fix lookuing up of undefined variables
- Fix nodemanager issue on version 12.2.1.1

## 2.1.4

- Add support for WebLogic and Fusion 12.2.1.1

## 2.1.3

- [domain] fix old routie call in jrf template
- [software_version] Added support for multiple software trees
- [core] Add geppetto  project file
- Security fixes

## 2.1.2

- [bsu] extract increaed_memory setting for BSU patches
- [software] Fix quoting issue

## 2.1.1

- [cluster_node] Make ports user configurable

## 2.1.0

- Added support for WebLogic 12.2.1

## 2.0.0

- Changed name to wls_install

## 1.0.39

- Works & Tested on puppet 4.2.1
- Oracle Forms & Reports 11.1.1.7 or 11.1.2 support
- Wls_server new attributes frontendhost, frontendhttpport and frontendhttpsport

## 1.0.38

- wls_server new attributes auto_restart & autokillwfail for automatic restart when the server crashes, or automatically kill when the server hangs
- wls_jms_queue, wls_jms_topic new attribute messagelogging
- wls_domain new attributes setinternalappdeploymentondemandenable, setconfigbackupenabled, setarchiveconfigurationcount, setconfigurationaudittype
- Dynamictargetting for wls_cluster, wls_datasource, wls_mail_session
- wls_datasource new attribute shrinkfrequencyseconds

## 1.0.37

- xa properties fix for wls_datasource
- custom weblogic home directory for WebLogic 10.3 and BSU patch
- target attribute used in wls types are now idempotent

## 1.0.36

- support for FMW installation which has 3 install files like oim/oam 11.1.2.3
- Webtier configuration for OAM
- wls_server_channel added keystore attributes
- wls_jms_queue ForwardDelay bug plus new attribute templatename
- wls_datasource new attributes row prefetch and initsql
- wls_workmanager new attribute fairshare
- wls_coherence_template new attribute classpath
- wls_deployment bug when version is none

## 1.0.35

- custom wls resource types now also supports t3s with customtrust done by wls_settings
- adminserver_ssl_port parameter on the domain.pp manifest
- wls_settings don't show the password in the output
- new resource type wls_jdbc_persistence_store
- new resource type wls_jms_template
- wls_deployment planpath fixes
- wls_datasource fixes
- removed default value -1 on forward delay on wls_jms_queue
- wls_server, new attribute listenportenabled
- wls_jms_connection_factory, xa fix plus new attributes localjndiname, defaultdeliverymode, defaultredeliverydelay
- wls_workmanager_constraint, Add the ability to manage fairshare class.

## 1.0.34

- Copydomain FMW apps_dir fix
- FTP Resource adapter plus resource adapter fixes
- New type wls_coherence_server
- Moved 12c nodemanager properties from domain.pp to nodemanager.pp so custom trust will also work
- Added urandom fixes and use notify when there is rngd configuration refresh

## 1.0.33

- added ESS (enterprise schedular) to OSB domain + FMW cluster option
- RCU prefix compare check fix ( Uppercase )
- SOA FMW cluster fixes for latest 12.1.3 soa patch
- SOA FMW cluster fix for soa with bam
- Java tmp dir option for 12c FMW software install
- wls_server, new attribute WeblogicPluginEnabled
- Optional DefaultUserNameMapperAttributeType fix in wls_identity_asserter
- Added bash shell to su -c commands like opatch, bsu, wls_adminserver, rcu types

## 1.0.32

- new wls_singleton_service type
- wls_jms_bridge_destination fix for username and password
- fiddyspence/sleep fix so it works with hiera and string value as input
- added log file to tmp dir + level for the weblogic 10.3 or 11g installation output
- Multiple targets for wls_jms_module type
- new wls_deployment attributes for stagingmode, remote and upload
- able to provide the sys username for the FMW domain RCU action
- derby flag on false in setDomainEnv when it is an OSB or SOA domain

## 1.0.31

- wls_jms_queue, new attribute forwarddelay
- wls_foreign_server_object, bug when removing object plus also removing dependencies
- wls_cluster, new attribute clusteraddress
- nodemanager.properties was overwritten in case of weblogic 12c and a domain extension
- nodemanager with 12c didn't start when log_dir was empty

## 1.0.30

- download dir dependency cycle error between weblogic and domain manifest.
- bsu unzip -o option instead of -n so the new readme is also added to the cache_dir
- wls_server, new attributes log_redirect_stderr_to_server, log_redirect_stdout_to_server, restart_max, log_http_file_count, log_http_number_of_files_limited, bea_home
- wls_jmsserver, new attributes bytes_maximum, allows_persistent_downgrade
- wls_datasource, new attributes secondstotrustidlepoolconnection, testfrequency, connectioncreationretryfrequency
- wls_server_channnel, new attributes publicport, max_message_size

## 1.0.29

- calculated_listen_port attribute for wls_dynamic_cluster
- mincapacity, statementcachesize, testconnectionsonreserve for wls_datasource
- wls_managedserver type fix when target is cluster, doesn't use ps -ef but uses wlst to check the cluster status
- new wls_messaging_bridge wls type
- new wls_jms_bridge_destination wls type
- wls_setting added a 'default' entry in wls_settings.yaml even when default is not used

## 1.0.28

- new wls_identity_asserter type for customising default identy asserter
- xaproperties attributes in wls_datasource
- better error handling for wls_authentication_provider ordering
- option to skip the OPSS security store migration from file to the database in fmwcluster.pp
- Custom type for oracle weblogic/domain directory structure instead of using a structure manifest
- logintimeout attribute for wls_server
- added some extra autorequire on wls resource types

## 1.0.27

- bug fixes in auto require and post classpath parameter bug when running in debug mode
- wls_multi_datasource resource type added

## 1.0.26

- auto require based on the wls resource parameters, no need to use require on the all wls resource types
- wls_adminserver type used plain as a default in nmconnect

## 1.0.25

- Auto require on wls resource types
- urandom fix for rngd service on RedHat Family version 7
- Secure replication parameter for wls_cluster
- ignore ldap providers for wls_user & wls_group
- Support for nodemanagers without security ( plain, with nodemanager_secure_listener = false) on control.pp, nodemanager.pp & domain.pp

## 1.0.24

- Wls_setting resource type check for required attributes
- Timeout parameter bug on all wls resource types ( the default 120 was always used)
- Nodemanager.pp exec sleep command replaced by fiddyspence/sleep resource type, will check every 2 seconds with netstat

## 1.0.23

- Solaris 11 fixes for nodemanager, wls_adminserver & wls_managedserver resource types
- wls_server resource type changes like: check for Adminserver creation/deletion, new properties tunnelingenabled, log_http_format_type, log_http_format, default_file_store, log_datasource_filename
- wls_domain resource type properties: platform-m-bean-server-enabled, platform-m-bean-server-used, show-archived-real-path-enabled
- wls_jms_connection_factory resource type properties: client-id-policy, subscription-sharing-policy, messages-maximum, reconnect-policy, load-balancing-enabled, server-affinity-enabled, attach-jmsx-user-id
- changed oraInst.loc permissions to 0755

## 1.0.22

- fix for copydomain when the standard domains location is used
- enable storage on wls_coherence_cluster
- AdminServer option to listen on all interfaces, adminserver_listen_on_all_interfaces = true on domain.pp

## 1.0.21

- puppet custom type for 12.1.2, 12.1.3 RCU, checks first if it already exists
- refactor all domains py scripts to standard one with an FMW extension (optional)
- fmw temp directory bug fix

## 1.0.20

- unset DISPLAY on install/configurations actions to avoid X timeout
- exclude the standard puppet attributes from the wls_setting yaml files
- Print the WLST scripts of all the wls types when puppet runs in debug mode
- Added new attributes log_http_filename & log_datasource_filename to the wls_server type
- SOA Cluster 12.1.3 fix for activating soa-infra application
- control the startup delay for the nodemanager with the sleep parameter
- option to assign the jrfcluster to a opss database

## 1.0.19

- changed property and removed propertyvalues of wls_mail_session, now there is no change detected when there is a different sorting
- changed users of wls_group, no change when there is a different sorting
- removed extrapropertiesvalues of wls_datasource, you can use now extraproperties with key=value,key1=value
- removed extrapropertiesvalues of wls_foreign_server, you can use now extraproperties with key=value,key1=value
- New Order parameter on the wls_authentication_provider type so you can change the order
- Timout parameter for all the wls types, can be used to override the default timeout (120s) on every wls resource
- MaxMessageSize parameter for wls_server resource type

## 1.0.18

- small fix for the server_template type with the arguments parameter
- Frontend parameters for wls_cluster
- Option to skip RCU with a domain creation ( weblogic > 12.1.2)
- new WebLogic type wls_mail_session
- new parameter default file store with wls_server

## 1.0.17

- utils.py fix for multiple domains
- Refactor for rubocop warnings

## 1.0.16

- Gridlink support for the Datasource type
- Extra properties can now be removed in a update of the Datasource
- Refactor domain py scripts and use a utils.py script for common functions

## 1.0.15

- RCU 12.1.3 support for MFT
- BSU fix for hard mdw path in patch policy
- OPatch, check the outcome of the action else fail
- SOA Cluster also works for FMW version 11.1.1.6
- wls_server type new attributes two_way_ssl, client_certificate_enforced
- wls_authentication_provider type now works for DefaultIdentityAsserter

## 1.0.14

- Change log Tab for puppetlabs forge

## 1.0.13

- Support for multiple jrf clusters
- New WLS 12c types like wls_server_template, wls_coherence_cluster, wls_dynamic_cluster

## 1.0.12

- SOA 12.1.3 Cluster support
- 12.1.3 FMW fixes
- BSU policy patch
- OAM & OIM cluster support
- 11g option to associate WebTier with a domain

## 1.0.11

- OSB 12.1.3 Cluster support
- FMW domains update for datasources based on servicetable
- Target & targettype on all wls types expects an array
- Same for servers parameter on wls_domain type
- Same for users parameter on wls_group type
- Same virtualhostnames parameter on wls_virtual_host
- Same for jndinames, extraproperties, extrapropertiesvalues parameters on wls_datasource & wls_foreign_server

## 1.0.10

- fixed WebLogic 12.1.2 & 12.1.3 standard domain bug.

## 1.0.9

- WebLogic 12.1.3 (infra) support
- Support for 12.1.3 SOA,OSB,B2B,MFT installation
- 12.1.3 Standard, ADF, SOA, OSB domain (no cluster)
- wls_adminserver type fix when using no custom trust

## 1.0.8

- wls_server pass server arguments as an array, as it makes it easier to use references in YAML
- Added log file options to wls_server

## 1.0.7

- wls_adminserver,wls_managedserver type to start,stop and refresh a managed server ( or subscribe to changes and do an autorestart )
- BSU
- Opatch
- Resource adapter
- Small nodemanager fix

## 1.0.6

- Readme with links
- wls types title cleanup
- Multiple resource adapter entries fix
- wls_domain fix
- bsu & opatch also works on < puppet 3.2
- hiera vars without an undef default

## 1.0.5

- wls_domain type to modify JTA,Security,Log & JPA
- Oracle Unified Directory install, domain, instances creation
- OUD control

## 1.0.4

- wls_deployment type/provider
- Post_classpath param on wls_setting
- WebTier for 12.1.2 and 11.1.1.7
- OIM & OAM 11.1.2.1 & 11.1.2.2 support with OHS OAM Webgate

## 1.0.3

- WLST Domain daemin for fast WLS types execution
- BSU & OPatch absent option and better output when it fails

## 1.0.2

- Custom Identity and Custom Trust

## 1.0.1

- Multi domain support with Puppet WLS types and providers
