# frozen_string_literal: true

#
# This function logs data from wls_install module.
#
#
# See the file "LICENSE" for the full license governing this code.
#
Puppet::Functions.create_function(:'wls_install::log') do
  def log(msg, level = :info)
    Puppet::Util::Log.create(
      :level => level,
      :message => msg,
      :source => 'wls_install_functions'
    )
  end
end
